//
// Created by Egor Salkov on 16.12.2020.
//
#include <time.h>
#include <string>
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <iterator>
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>

#ifndef SEM3_DZ1_PART_1_H
#define SEM3_DZ1_PART_1_H

#endif //SEM3_DZ1_PART_1_H
using namespace std;


void outputVector(const vector<int> &fromf) {
    vector<int>::const_iterator Citer;
    for (Citer = fromf.cbegin(); Citer != fromf.cend(); ++Citer) {
        cout << *Citer << " ";
    }
    cout << "\n";
}


//!1.1.	Функция, выгружающая данные с использованием файловых потоков
void CreateData_file(const string &filename) {
    srand(time(NULL));
    ofstream file(filename);
    if (!file) {
        throw "File can not be opened";
    }
    for (int i = 0; i < 100; ++i) {
        int a = rand() % 101 - 50;
        file << a << " ";
    }
}

//!1.2.	Функция, использующая алгоритм generate для инициализации вспомогательного контейнера
//!и алгоритм copy для вывода его содержимого в файл с использованием потоковых итераторов
void CreateData_iter(const string &filename) {
    srand(time(NULL));
    vector<int> tofile(100);
    generate(tofile.begin(), tofile.end(), []() { return rand() % 101 - 50; });

    ofstream file2(filename);
    if (!file2) {
        throw "File can not be opened";
    }
    copy(tofile.begin(), tofile.end(), ostream_iterator<int>(file2, " "));

}

//!2.1.	Функция, загружающая данные с использованием файловых потоков.
template<typename ContainerType>
void LoadData_file(ContainerType &container, const string &filename) {
    ifstream file(filename);
    if (!file) {
        throw "File can not be opened";

    }
    int n;
    while (!file.eof()) {
        file >> n;
        container.push_back(n);
    }
}

//!2.2 Функция, загружающая данные с использованием потоковых итераторов и алгоритма copy
template<typename ContainerType>
void LoadData_iter(ContainerType &container, const string &filename) {
    ifstream file(filename);
    if (!file) {
        throw "File can not be opened";
    }
    copy(istream_iterator<typename ContainerType::value_type>(file),
         istream_iterator<typename ContainerType::value_type>(), back_inserter(container));
}


//!3.1 шаблонная функция, принимающая последовательный контейнер данного типа. Должна добавлять в конец контейнера результата сумму и
//!среднее арифметическое элементов контейнера по абсолютной величине*
template<class Type>
void Modify_1(Type &container) {
    int sum = 0;
    int sum_abs = 0;
    int col = 0;
    auto iter = container.begin();
    for (; iter != container.end(); ++iter) {
        sum += *iter;
        ++col;
        sum_abs += abs(*iter);
    }

    iter = container.begin();
    for (; iter != container.end(); ++iter) {
        if (*(iter) == 0)
            *iter = sum / col;
    }

    container.push_back(sum_abs);
    container.push_back(sum_abs / col);
}

//!3.2 функция, принимающая аргументы-итераторы*
template<typename IteratorType>
void Modify_2(IteratorType begin, IteratorType end) {
    auto sum = 0;
    int col = 0;
    IteratorType iter = begin;
    for (; iter != end; ++iter) {
        sum += *iter;
        ++col;
    }

    iter = begin;
    for (; iter != end; ++iter) {
        if (*(iter) == 0)
            *iter = sum / col;
    }
}

//!3.3 функция, использующая алгоритм for_each(). Конкретную операцию передавать в виде функционального объекта
//! или лямбда-функции*
template<class Type>
void Modify_3(Type &container) {
    int sum = 0;
    int col = 0;

    for (auto iter = container.begin(); iter != container.end(); ++iter) {
        sum += *iter;
        ++col;
    }

    for_each(container.begin(), container.end(), [&](auto &cur) { if (cur == 0) { cur = sum / col; }});

}

//!4.1 функция, использующая алгоритм transform() и потоковые итераторы для одновременного считывая данных из файла,
//! их преобразования и вывода в файл результата*
template<typename IteratorType>
void Modify_4(const string &fileName, IteratorType begin, IteratorType end) {


    int sum = 0;
    int col = 0;
    IteratorType iter = begin;
    for (; iter != end; ++iter) {
        sum += *iter;
        ++col;
    }
    float sred = sum / col;
    auto file = std::ofstream(fileName);
    transform(begin, end, std::ostream_iterator<int>(file, " "), [sred](auto &i) {
        if (i == 0)
            return i = sred;
        return i;
    });

}

//!4.1 Функция, выгружающая данные с использованием файловых потоков.
template<typename ContainerType>
void OutputResult_file(const string &filename, ContainerType &container) {
    ofstream file(filename);
    if (!file) {
        throw "File can not be opened";
    }
    for (auto &a : container)
        file << a << ' ';
    file.close();

    cout << " Resalt " << endl;
    file.open(filename, ios::in);
    cout << file.rdbuf();
    file.close();
}

//!4.2.	Функция, использующая алгоритм copy для вывода контейнера в файл с использованием потоковых итераторов
template<typename ContainerType>
void OutputResult_iter(const string &filename, ContainerType &container) {
    auto file = std::ofstream(filename);
    std::copy(container.begin(), container.end(), std::ostream_iterator<int>(file, " "));
    file.close();
    cout << " Resalt " << endl;
    ostream_iterator<int> input(cout, " ");
    copy(container.begin(), container.end(), input);
}
